var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import classnames from 'classnames';

import { baseThemeStyleName, flagIconClassesPrefix, flagIconClassesPrefixName } from './constants';

export var makeClassesObject = function makeClassesObject(props, options) {
  var _obj;

  var code = props.code,
      _props$flip = props.flip,
      flip = _props$flip === undefined ? '' : _props$flip,
      _props$size = props.size,
      size = _props$size === undefined ? '' : _props$size,
      _props$squared = props.squared,
      squared = _props$squared === undefined ? false : _props$squared,
      rotate = props.rotate,
      className = props.className;
  var themeStyles = options.themeStyles,
      useCssModules = options.useCssModules;


  var obj = (_obj = {}, _defineProperty(_obj, flagIconClassesPrefixName, true), _defineProperty(_obj, flagIconClassesPrefix + 'squared', squared), _defineProperty(_obj, '' + flagIconClassesPrefix + size, size), _defineProperty(_obj, '' + flagIconClassesPrefix + code, code), _defineProperty(_obj, flagIconClassesPrefix + 'flip-' + flip, flip), _defineProperty(_obj, flagIconClassesPrefix + 'rotate-' + (rotate || ''), rotate), _defineProperty(_obj, baseThemeStyleName, useCssModules && themeStyles && themeStyles[baseThemeStyleName]), _obj);

  if (className && useCssModules) {
    obj = _extends({}, obj, _defineProperty({}, className, true));
  }
  return obj;
};

export default (function (props, options) {
  return classnames(makeClassesObject(props, options));
});